class TypeError1(Exception):
    pass
class TypeError2(Exception):
    pass

import arcgisscripting, os, arcpy, string, math, time
from arcpy import env
from math import *

env.overwriteOutput="True"
#check if ArcInfo licence vailable

if arcpy.ProductInfo() == "ArcInfo":
    
    #set working files and values and input values

    ua_raster=arcpy.GetParameterAsText(0)
    units_layer=arcpy.GetParameterAsText(1)
    
    result=arcpy.GetCount_management(units_layer)
    count=int(result.getOutput(0))
    
    unit_code=arcpy.GetParameterAsText(2)
    people=arcpy.GetParameterAsText(3)
    out_dir=arcpy.GetParameterAsText(4)
    out_shape1=arcpy.GetParameterAsText(5)
    out_shape=os.path.basename(out_shape1)
    
    #working databases and datasets, prepared in the first script
    arcpy.CreateFileGDB_management(out_dir, "sprawl.gdb", "9.3")
    point_FDS=out_dir+"\\sprawl.gdb\\urban_points"
    WrkGDB=out_dir+"\\sprawl.gdb"
    sr = arcpy.Describe(ua_raster).spatialReference
    arcpy.CreateFileGDB_management(out_dir, "metrics.gdb", "9.3")
    metrics=out_dir+"\\metrics.gdb"
    arcpy.CreateFeatureDataset_management(out_dir+"\\sprawl.gdb", "reference_units", sr)
    unit_FDS=out_dir+"\\sprawl.gdb\\reference_units"
    arcpy.CreateFeatureDataset_management(out_dir+"\\sprawl.gdb", "urban_points", sr)
    try:
        report_file=out_dir+"\\"+"step2_working_report.txt"
        s=open(report_file,'w')
        s.write("Report units layer: "+units_layer+"\n")
        s.write("Report units layer contains "+str(count)+" reference units"+"\n")
        s.write("Output file: "+out_shape+"\n")    
        s.write("--------------------------------------------------"+"\n")
        fields=arcpy.ListFields(units_layer,unit_code)
        for field in fields:
            typ=format(field.type)
            if typ=="String":
                raise TypeError1
            else:
                fields=arcpy.ListFields(units_layer,people)
                for field in fields:
                    typ=format(field.type)
                if typ=="String":
                    raise TypeError2
                elif typ=="Date":
                    raise TypeError2
                elif typ=="Blob":
                    raise TypeError2
                else:
                
                #Preparatory works
                                
                    RES = int(str(arcpy.GetRasterProperties_management(ua_raster, "CELLSIZEX")))
                
                    outpoint=out_dir+"\\work_SI.gdb\\Si_val\\Si_values"
                
                #intersect point layer with statistical units
                    arcpy.AddMessage("The computation of the build-up areas inside each reporting unit is running...")
                    ex1="\""+units_layer+"\""+";"+"\""+outpoint+"\""
                    ex2=point_FDS+"\\st_units_pnt"
                    arcpy.Intersect_analysis(ex1,ex2)
                
                    ex3=WrkGDB+"\\st_units_pnt_sum"
                    arcpy.Frequency_analysis (ex2, ex3, unit_code)
                    arcpy.AddField_management(ex3, "urban_area", "DOUBLE")
                    arcpy.AddField_management(ex3, "resolution", "DOUBLE")
                    arcpy.CalculateField_management(ex3,"resolution",RES)
                    arcpy.CalculateField_management(ex3,"urban_area","[FREQUENCY]*[resolution]*[resolution]")
                    arcpy.CopyFeatures_management(units_layer, metrics+"\\SU")
                    arcpy.JoinField_management (metrics+"\\SU", unit_code, ex3, unit_code, "urban_area")
                               
                    arcpy.AddField_management(metrics+"\\SU", "pom", "DOUBLE")
                    pole="["+people+"]"
                    arcpy.CalculateField_management(metrics+"\\SU","pom",pole)
                    
                

               ##metrics calculation
                    
                    arcpy.CreateTable_management (WrkGDB, "metric")
                    arcpy.AddField_management(WrkGDB+"\\metric", "FREQUENCY", "LONG")
                    arcpy.AddField_management(WrkGDB+"\\metric", "SUM_s", "DOUBLE")
                    arcpy.AddField_management(WrkGDB+"\\metric", "COUNT_s", "LONG")
                    arcpy.AddField_management(WrkGDB+"\\metric", "MEAN_key", "DOUBLE")
                    arcpy.AddMessage("                                                 ")
                    arcpy.AddMessage("                                                 ")
                
                    arcpy.AddField_management(ex2, "key", "DOUBLE")
                    pole2="["+unit_code+"]"
                    arcpy.CalculateField_management(ex2,"key",pole2)
                
                    arcpy.AddMessage("Calculation of the metrics for the individual reporting units is starting")
                    arcpy.Statistics_analysis (ex2, metrics+"\\metric", [["grid_code", "SUM"],["grid_code", "COUNT"]],"key")
                    arcpy.AddField_management(metrics+"\\metric", "SUM_s", "DOUBLE")
                    arcpy.AddField_management(metrics+"\\metric", "COUNT_s", "DOUBLE")
                
                    arcpy.CalculateField_management(metrics+"\\metric", "SUM_s","[SUM_grid_code]")
                    arcpy.CalculateField_management(metrics+"\\metric", "COUNT_s","[COUNT_grid_code]")
                
                
                    arcpy.JoinField_management (metrics+"\\SU", unit_code, metrics+"\\metric", "key", ["SUM_s", "COUNT_s"])

                    
                    arcpy.CopyFeatures_management(metrics+"\\SU", out_shape1)
                
                    arcpy.AddField_management (out_shape1, "unit_area", "DOUBLE", "","0")
                
                    arcpy.AddField_management (out_shape1, "PBA", "DOUBLE","10","5")
                    arcpy.AddField_management (out_shape1, "DIS", "DOUBLE","10","5")
                    arcpy.AddField_management (out_shape1, "w1DIS", "DOUBLE","10","5")
                    arcpy.AddField_management (out_shape1, "TS", "DOUBLE","15","1")
                    arcpy.AddField_management (out_shape1, "UP", "DOUBLE","10","5")
                    arcpy.AddField_management (out_shape1, "UD", "DOUBLE","10","1")
                    arcpy.AddField_management (out_shape1, "w2UD", "DOUBLE","10","5")
                    arcpy.AddField_management (out_shape1, "LUP", "DOUBLE","15","1")
                    arcpy.AddField_management (out_shape1, "WUP", "DOUBLE","10","5")
                    arcpy.MakeFeatureLayer_management(out_shape1,"shape_lyr")
                    arcpy.SelectLayerByAttribute_management("shape_lyr", "NEW_SELECTION", "\"COUNT_s\" <> 0")
                
                    arcpy.CalculateField_management("shape_lyr", "unit_area", "[Shape_Area]")
                    arcpy.CalculateField_management("shape_lyr", "PBA", "([urban_area])/[unit_area]")
                    arcpy.CalculateField_management("shape_lyr", "DIS", "[SUM_s]/[COUNT_s]")
                    arcpy.CalculateField_management("shape_lyr", "TS", "[urban_area]*[DIS]")

                    arcpy.CalculateField_management("shape_lyr", "UP", "[TS]/[unit_area]")
                    arcpy.CalculateField_management("shape_lyr", "UD", "[pom]/([urban_area]/1000000)")

                    arcpy.CalculateField_management("shape_lyr", "w1DIS", "0.5 + (EXP(0.294432 * [DIS] - 12.955) / (1  + EXP(0.294432 * [DIS]  - 12.955)))")
                    arcpy.CalculateField_management("shape_lyr", "w2UD", "EXP(4.159 - 0.000613125 * [UD]) / (1  + EXP(4.159 - 0.000613125 * [UD]))")
                    arcpy.CalculateField_management("shape_lyr", "WUP", "[UP]  * EXP(4.159 - 0.000613125 * [UD]) / (1  + EXP(4.159 - 0.000613125 * [UD])) * (0.5 + EXP(0.294432 * [DIS] - 12.955) / (1  + EXP(0.294432 * [DIS]  - 12.955)))")

                    arcpy.SelectLayerByAttribute_management("shape_lyr", "SUBSET_SELECTION", "\"pom\" <> 0")
                    arcpy.CalculateField_management("shape_lyr", "LUP", "(1/[UD])*1000000")

                    arcpy.SelectLayerByAttribute_management("shape_lyr", "NEW_SELECTION", "\"COUNT_s\" <> 0")
                    arcpy.SelectLayerByAttribute_management("shape_lyr", "SUBSET_SELECTION", "\"pom\" = 0")
                    arcpy.CalculateField_management("shape_lyr", "LUP", "-1")
                    
                    arcpy.AddMessage("                                                 ")
                    arcpy.AddMessage("                                                 ")
                    arcpy.AddMessage("Metrics are calculated. Result is stored in the "+out_shape1+"file")
                    arcpy.AddMessage("Next step (optional)- run 3_Cleaning tool")
                    s.write("---------------------------------------"+"\n")
                    s.write("Process is finished")
                    s.close()
                    arcpy.DeleteField_management(out_shape1, ["pom", "sum_s","count_s","Shape_Leng","Shape_Area"])
                    
    except TypeError1:
        arcpy.GetMessages(2)
        arcpy.AddError("The reporting unit identifier field must be numeric")
        s.write("Error-The reporting unit identifier field must be numeric"+"\n")
        s.close()
    except TypeError2:
        arcpy.GetMessages(2)
        arcpy.AddError("The number of inhabitats/jobs field must be numeric")
        s.write("The number of inhabitats/jobs field must be numeric"+"\n")
        s.close()
    except:
        errCode=arcpy.GetReturnCode(3)
        if str(errCode) == "10320":
              
            arcpy.AddError("Error generated by Raster to Point tool")
            arcpy.AddMessage("There was not enough free memory or disk space available to complete the operation")
            s.write("Error generated by Raster to Point tool"+"\n")
            s.write("There was not enough free memory or disk space available to complete the operation"+"\n")
            s.close()
        elif str(errCode) == "10427":
            arcpy.AddError("A problem occurred while writing to the output feature class")
            arcpy.AddMessage("Possible solution:")
            arcpy.AddMessage("Ensure that there is enough free disk space at the specified location to accommodate the expected size of the output. If there is not, either choose a different location with more space or increase the available space at the specified location by removing unnecessary data and trying again.")
            s.write("A problem occurred while writing to the output feature class"+"\n")
            s.write("Possible solution:"+"\n")
            s.write("Ensure that there is enough free disk space at the specified location to accommodate the expected size of the output. If there is not, either choose a different location with more space or increase the available space at the specified location by removing unnecessary data and trying again."+"\n")
            s.close()
        elif str(errCode) == "40002":
            arcpy.AddError("Problems with memory - not enough memory")
            arcpy.AddMessage("This error may be due to one of the following conditions:")
            arcpy.AddMessage("- There is not enough virtual memory, or the available memory is fragmented.")
            arcpy.AddMessage("- The page file size is too small.")
            arcpy.AddMessage("- Not enough memory is available in the temporary directory.")
            s.write("Problems with memory - not enough memory"+"\n")
            s.write("This error may be due to one of the following conditions:"+"\n")
            s.write("- There is not enough virtual memory, or the available memory is fragmented."+"\n")
            s.write("- The page file size is too small."+"\n")
            s.write("- Not enough memory is available in the temporary directory."+"\n")
            s.close()
        elif str(errCode) == "10038":
            arcpy.AddError("There was an error in creating output in the workspace (geodatabase or directory).")
            arcpy.AddMessage("Possible solution:")
            arcpy.AddMessage("Check that you have proper write permissions to the output workspace and that there is sufficient available disk space.")
            s.write("There was an error in creating output in the workspace (geodatabase or directory)."+"\n")
            s.write("Possible solution:"+"\n")
            s.write("Check that you have proper write permissions to the output workspace and that there is sufficient available disk space."+"\n")
            s.close()
        else:
            arcpy.AddMessage(arcpy.GetMessages(2))
        
else:
    prd=arcpy.ProductInfo()
    arcpy.AddError("Need an ArcInfo licence to run this tool")
    arcpy.AddMessage("Only "+str(prd)+" licence is available")
    s.write("Need an ArcInfo licence to run this tool"+"\n")
    s.write("Only "+str(prd)+" licence is available"+"\n")
    s.close()
